<?php
/*
Plugin Name: Dilemma Plugin
Plugin URI: http://dilemmaplugin.com/
Description: Creates a Dilemma "Would you rather" voting game on your website.
Version: 3.8
Author: 20SCript
Author URI: http://www.20script.ir
*/

    #} Hooks
    
    #) Translations
	function dilemma__languageInit() {
		load_plugin_textdomain( 'Dilemma', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
	}
	add_action('plugins_loaded', 'dilemma__languageInit');

    #} Install/uninstall
    register_activation_hook(__FILE__,'dilemma__install');
    register_deactivation_hook(__FILE__,'dilemma__uninstall');
    
    #} general
    add_action('init', 'dilemma__init');
    add_action('admin_menu', 'dilemma__admin_menu'); #} Initialise Admin menu
    

	#} Initial Vars
	global $dilemma_db_version;
	$dilemma_db_version             	   = "1.0";
	$dilemma_version          		       = "3.7";
	$dilemma_activation                    = '';


	#} Urls
    global $dilemma_urls;
    $dilemma_urls['home']      = 'http://dilemmaplugin.com/';
    $dilemma_urls['docs']      = plugins_url('/documentation/index.html',__FILE__);
	$dilemma_urls['newsFeed']      = 'http://dilemmaplugin.com/feed/';
	$dilemma_urls['forum']      = 'http://epicplugins.com/support-forums/';
    $dilemma_urls['updateCheck']	= 'http://www.epicplugins.com/api/';
	$dilemma_urls['regCheck']		= 'http://www.epicplugins.com/registration/';
	$dilemma_urls['subscribe'] 	= "http://eepurl.com/tW_t9";

	
	#} Page slugs
    global $dilemma_slugs;
    $dilemma_slugs['config']           = "dilemma-plugin-config";
    $dilemma_slugs['settings']         = "dilemma-plugin-settings";

	#} Taxonomies
	global $dilemma_taxonomy;
	$dilemma_taxonomy['cats'] = 'dilemma-cats';
	$dilemma_taxonomy['tags'] = 'dilemma-tags';


	#} Install function
	function dilemma__install(){

    #} Default Options

    add_option('dilIP','yes','','yes');
	add_option('dil_love','yes','','yes');
	add_option('ds','no','','yes');
	add_option('dil_aff','mikemayhem3030','','yes');
	add_option("dilemma_db_version", 		$dilemma_db_version);
    add_option("dilemma_version",			$dilemma_version);
	
	add_option('diltimer', 'yes');
	
	dil_install();
    
    $current_user = wp_get_current_user();    //email the current user rather than admin info more likely to reach a human email 
	$userEmail = $current_user->user_email;
    $userName =  $current_user->user_firstname;
	$LastName =  $current_user->user_lastname;
	$plugin = 'Dilemma';
	
	if(get_option('ds') == 'no'){    //only send them an install email once
	dilemma_sendReg($userEmail,$userName,$plugin);
	}
	
 
	}
	
	
	global $dil_db_version;
	$dil_db_version = "1.0";
	$aff = get_option('dil_aff');

   function dil_install() {
   global $wpdb;
   global $dil_db_version;

   $table_name = $wpdb->prefix . "dil_ip";
      
   $sql = "CREATE TABLE $table_name (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  dil_id mediumint(9) NOT NULL,
	  dil_ip text NOT NULL,
	  UNIQUE KEY id (id)
	    );";

	   require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	   dbDelta($sql);
	 
	   add_option("dil_db_version", $dil_db_version);

	}



	#} Uninstall
	function dilemma__uninstall(){
	    
	    #} Removes initial settings, leaves config intact for upgrades.
	    delete_option("dilemma_db_version");
	    delete_option("dilemma_version");
	    delete_option("dilemma_activation");
	    
	}



#} Initialisation - enqueueing scripts/styles
function dilemma__init(){
  
    global $dilemma_slugs, $dilemma_taxonomy; #} Req
    

	
    
    #} Admin & Public
    wp_enqueue_script("jquery");
	wp_enqueue_script( 'jquery-form',array('jquery')); 
    if (!is_admin()) {
    wp_enqueue_script('dilemma-ajax',plugins_url('/js/dilemma.js',__FILE__),array('jquery'));
    wp_localize_script( 'dilemma-ajax', 'dilemma_vars', array(
			'ajaxurl' => admin_url( 'admin-ajax.php' ),
			'str_voted_leftview' => __( ' disagrees', 'Dilemma' ),
			'str_voted_rightview' => __( ' agrees', 'Dilemma' ),
	) );


    wp_enqueue_style('dilemmacss', plugins_url('/css/dilemma.css',__FILE__) );
	}
    #} Admin only
    if (is_admin()) {
     wp_enqueue_script("jquery");
    #} Admin CSS
    wp_enqueue_style('dielmmaadmincss', plugins_url('/css/dilemmaadmin.css',__FILE__) );
	 wp_enqueue_style('epiccss', plugins_url('/css/epic.css',__FILE__) );
    }
    
    #} Custom post type
    $labels = array(
                'name' => _x('Dilemma', 'post type general name', 'Dilemma'),
                'singular_name' => _x('Dilemma', 'post type singular name', 'Dilemma'),
                'add_new' => _x('Manually Add Dilemma', 'dilemma', 'Dilemma'),
                'add_new_item' => __('Manually Add New Dilemma', 'Dilemma'),
                'edit_item' => __('Edit Dilemma', 'Dilemma'),
                'new_item' => __('New Dilemma', 'Dilemma'),
                'view_item' => __('View Dilemma', 'Dilemma'),
                'search_items' => __('Search Dilemmas', 'Dilemma'),
                'not_found' =>  __('No dilemmas found', 'Dilemma'),
                'not_found_in_trash' => __('No dilemmas found in Trash', 'Dilemma'),
                'parent_item_colon' => '',
                'menu_name' => 'Dilemmas'
            );
    $args = array(
                'labels' => $labels,
                'public' => true,
                'publicly_queryable' => true,
                'show_ui' => true,
                'show_in_menu' => true,
                'query_var' => true,
                'rewrite' => true,
                'capability_type' => 'post',
                'has_archive' => true,
                'hierarchical' => false,
                'menu_icon' => plugins_url('i/dilemma.png',__FILE__),
                'menu_position' => null,
                'supports' => array( 'title', 'author','comments')
            );
    #} Register it
    register_post_type('dilemma',$args);

    #} Initialize New Taxonomy Labels
    $labels = array(
                'name' => _x( 'Dilemma Categories', 'taxonomy general name', 'Dilemma' ),
                'singular_name' => _x( 'Dilemma Category', 'taxonomy singular name', 'Dilemma' ),
                'search_items' =>  __( 'Search Dilemma Categories', 'Dilemma' ),
                'all_items' => __( 'All Dilemma Categories', 'Dilemma' ),
                'parent_item' => __( 'Parent Dilemma Category', 'Dilemma' ),
                'parent_item_colon' => __( 'Parent Dilemma Category:', 'Dilemma' ),
                'edit_item' => __( 'Edit Dilemma Category', 'Dilemma' ),
                'update_item' => __( 'Update Dilemma Category', 'Dilemma' ),
                'add_new_item' => __( 'Add New Dilemma Category', 'Dilemma' ),
                'new_item_name' => __( 'New Dilemma Category Name', 'Dilemma' ),
            );
    #} Custom taxonomy for Dilemma Categories
    register_taxonomy($dilemma_taxonomy['cats'],array('dilemma'), array(
                'hierarchical' => true,
                'labels' => $labels,
                'show_ui' => true,
                'query_var' => true,
                'rewrite' => array( 'slug' => $dilemma_taxonomy['cats']),
                        ));

    #} Initialize New Taxonomy Labels
    $labels = array(
                'name' => _x( 'Dilemma Tags', 'taxonomy general name', 'Dilemma' ),
                'singular_name' => _x( 'Dilemma Tag', 'taxonomy singular name', 'Dilemma' ),
                'search_items' =>  __( 'Search Dilemma Tags', 'Dilemma' ),
                'all_items' => __( 'All Dilemma Tags', 'Dilemma' ),
                'parent_item' => __( 'Parent Dilemma Tag', 'Dilemma' ),
                'parent_item_colon' => __( 'Parent Dilemma Tag:', 'Dilemma' ),
                'edit_item' => __( 'Edit Dilemma Tag', 'Dilemma' ),
                'update_item' => __( 'Update Dilemma Tag', 'Dilemma' ),
                'add_new_item' => __( 'Add New Dilemma Tag', 'Dilemma' ),
                'new_item_name' => __( 'New Mash Dilemma Name', 'Dilemma' ),
            );
    #} Custom taxonomy for Project Tags
    register_taxonomy($dilemma_taxonomy['tags'],array('dilemma'), array(
                'hierarchical' => false,
                'labels' => $labels,
                'show_ui' => true,
                'query_var' => true,
                'rewrite' => array( 'slug' => $dilemma_taxonomy['tags']),
                        ));



}

#} Add le admin menu
function dilemma__admin_menu() {

    global $dilemma_slugs,$dilemma_menu; #} Req
    
    $dilemma_menu = add_menu_page( 'My Dilemma Menu', 'Dilemma', 'manage_options', $dilemma_slugs['config'], 'dilemma_menu', plugins_url('i/dilemma.png',__FILE__));
     add_submenu_page( $dilemma_slugs['config'], 'Settings', 'Settings', 'manage_options', $dilemma_slugs['settings'] , 'dilemma_pages_settings' );
}


#}Settings
function dilemma_pages_settings() {
    
    global $wpdb, $dilemma_urls, $dilemma_version;    #} Req
    
    if (!current_user_can('manage_options'))  {
        wp_die( __('You do not have sufficient permissions to access this page.','Dilemma') );
    }
    
    
?><div id="sgpBod">
          <div class='myslogo'><?php echo '<img src="' .plugins_url( 'i/dilemmalogo.png' , __FILE__ ). '" > ';   ?></div>
        <div class='mysearch'>
        	
        <?php dilemma_header(); ?>
            
                
         <?php
         	if(isset($_GET['save'])){ 
             if ($_GET['save'] == "1"){
                dilemma_html_save_settings();
             }
		    }
            if(!isset($_GET['save'])){
                dilemma_html_settings();
            }
    ?></div>
    

</div>
<?php
}

 function dilemma_wpmut_admin_scripts()
 {
 if(is_admin())
 {
 wp_enqueue_script('jquery');
 wp_enqueue_script('media-upload');
 wp_enqueue_script('thickbox');
 wp_enqueue_script('dilemma-admin',plugins_url('/js/dilemmaadmin.js',__FILE__), array('jquery','media-upload','thickbox'));
 }
 }
 
 function dilemma_wpmut_admin_styles()
 {
 if(is_admin())
 {
 wp_enqueue_style('thickbox');
 }
 }
 add_action('admin_print_scripts', 'dilemma_wpmut_admin_scripts');
 add_action('admin_print_styles', 'dilemma_wpmut_admin_styles');




function dilemma_html_settings(){
        
    global $wpdb, $dilemma_urls, $dilemma_slugs;  #} Req
    
    $dilConfig = array();
    $dilConfig['trans_id'] 		   =           get_option('dil_trans_id');    
    $dilConfig['dilIP'] 		   =           get_option('dilIP');   
	$dilConfig['diltimer']		   =		   get_option('diltimer'); 

    
    ?>
    

     <form action="?page=<?php echo $dilemma_slugs['settings']; ?>&save=1" method="post">
     <div class="postbox">
     <h3><label>General settings</label></h3>
     
     <table class="form-table" width="100%" border="0" cellspacing="0" cellpadding="6">
         
        <tr valign="top">
            <td width="25%" align="left"><strong>item purchase code:</strong></td>
            <td align="left"><input id=pstrans_id name=diltrans_id type="text" placeholder="item purchase code" size="20" value = '<?php echo $dilConfig['trans_id']; ?>' /><br><i>This is the purchase code contained in your License Certificate on CodeCanyon</i></td>
        </tr>

        <tr valign="top">
                        <td width="25%" align="left"><strong>One vote per IP:</strong></td>
                        <?php if($dilConfig['dilIP'] == 'yes'){ ?>
                        <td align="left">
                            <input type="radio" name="dilIP" value="yes" checked> Yes
                            <input type="radio" name="dilIP" value="no"> No
                            <br><i>Restrict the votes to one per IP address</i>
                        </td>
                        <?php }else{ ?>
                         <td align="left">
                            <input type="radio" name="dilIP" value="yes"> Yes
                            <input type="radio" name="dilIP" value="no" checked> No
                            <br><i>Restrict the votes to one per IP address</i>
                        </td>
                        <?php } ?>
         </tr>
         
                 <tr valign="top">
                        <td width="25%" align="left"><strong>Show the countdown timer for Next Dilemma?:</strong></td>
                        <?php if($dilConfig['diltimer'] == 'yes'){ ?>
                        <td align="left">
                            <input type="radio" name="diltimer" value="yes" checked> Yes
                            <input type="radio" name="diltimer" value="no"> No
                            <br><i>If set to yes a countdown timer will be used. If no a button</i>
                        </td>
                        <?php }else{ ?>
                         <td align="left">
                            <input type="radio" name="diltimer" value="yes"> Yes
                            <input type="radio" name="diltimer" value="no" checked> No
                            <br><i>If set to yes a countdown timer will be used. If no a button</i>
                        </td>
                        <?php } ?>
         </tr>

      
    </table>
    <p id="footerSub"><input class = "button-primary" type="submit" value="Save settings" /></p>
    </form>
</div>

<?php }



#} Save options changes
function dilemma_html_save_settings(){
    
    global $wpdb, $picsmash_urls, $picsmash_slugs;  #} Req
    
    $dilConfig = array();
    $dilConfig['dilIP'] 			=           $_POST['dilIP'];
    $dilConfig['trans_id'] 			=           $_POST['diltrans_id'];
	$dilConfig['diltimer']			=			$_POST['diltimer'];

    
    #} Save down
    update_option("dilIP", $dilConfig['dilIP']);
    update_option("dil_trans_id", $dilConfig['trans_id']);
	update_option("diltimer",$dilConfig['diltimer']);

    #} Msg
    dilemma_html_msg(0,"Saved options");
    
    #} Run standard
    dilemma_html_settings();
    
}







function dilemma_checkForMessages(){
    
    global $dilemma_urls;

    # First deal with legit purchases
    if (isset($_GET['legit'])){
        
        # Update
        update_option('dilemma_myo_firstLoadMsg',1);
        
        #} Set this here
        $flFlag = 1;
        
    } else $flFlag = get_option('dilemma_myo_firstLoadMsg');
    
    
    
    if (empty($flFlag)) {
        
        dilemma_html_msg(2,'<div class="sgThanks">
            <h3>Thank you for installing Dilemma!, only available on CodeCanyon!</h3>
            <p>This license entitles you to use Dilemma! on a single WordPress install.</br>
            </p>
                        
            <p>Its Easy to get started, you can work it out for yourself below or read the <a href="'.$dilemma_urls['docs'].'" target="_blank">Dilemma Support Manual</a>.<br />To keep up to date with Dilemma follow us on <a href="http://codecanyon.net/user/mikemayhem3030/follow/" target="_blank">CodeCanyon</a></p>
        
            <div class="sgButtons">
                <a class="buttonG" href="?page=dilemma-plugin-config&legit=true">I have a License</a>
                <a class="buttonBad" href="http://codecanyon.net/item/pics-mash-image-rating-tool/3256459">I need a License</a>
            </div>
                    
            <div class="clear"></div>
        </div>');
        
    }
    
}


#} ROOT page
function dilemma_pages_home(){
    	
	global $wpdb, $dilemma_slugs, $dilemma_urls;
	

    ?>

    
    
    <div class="postbox-container" id="main-container" style="width:75%;">
            <div class="postbox">
           <h3 style="text-align:center"><label>Welcome to Dilemma!</label></h3>
                <div class="inside">
                    <p style="text-align:center"><strong>Welcome to Dilemma</strong>: the Ultimate Yes/No Plugin for WordPress If you want to vote on future features or find out more about Dilemma! or find more cool plugins, check out the <br/><a href="http://epicplugins.com" target="_blank">epic plugins site</a>!</p>
                    <div id="SocialGalleryOptions">
                        <div><a href="admin.php?page=<?php echo $dilemma_slugs['settings']; ?>" class="SocialGalleryOB">Settings</a></div>
                        <div><a href="post-new.php?post_type=dilemma" class="SocialGalleryOB">Add Dilemmas</a></div>
                        <div><a href="http://dilemmaplugin.com/" target = "_blank" class="SocialGalleryOB">Visit Demo Site</a></div>
                    </div>
                    <div style="clear:both"></div>
                </div>
            </div>
            <div class="postbox">
                <h3 style="padding:8px;"><label><?php _e('Dilemma News', 'Dilemma' ); ?></label></h3>
                <div class="inside">
                	<?php dilemma_retrieveNews(); ?>
                </div>
            </div>  
   </div>

   <div class="postbox-container" id="side-container" style="width:24%;margin-left:1%">
            <div class="postbox">
                <h3 style="padding:8px;"><label><?php _e('Keep up to date','PicsMash'); ?></label></h3>
                <div class="inside">
                	<!-- Begin MailChimp Signup Form -->

					<style type="text/css">

					</style>
					<div id="mc_embed_signup">
					<form action="http://epicplugins.us6.list-manage.com/subscribe/post?u=1c0fcf180d7cda3d5add7ba76&amp;id=034a5859d6" method="post" id="mc-embedded-subscribe-form" name="mc-embedded-subscribe-form" class="validate" target="_blank" novalidate>
						<label for="mce-EMAIL">Subscribe to our mailing list</label>
						<input type="email" value="" name="EMAIL" class="email" id="mce-EMAIL" placeholder="email address" required>
						<br/><br/>
						<div class="clear"><input type="submit" value="Subscribe" name="subscribe" class = "button-primary" style = "float:right" id="mc-embedded-subscribe" class="button"></div>
					</form>
					</div>
					<div style = "clear:both"></div>
					
					<!--End mc_embed_signup-->

                </div>
            </div>
   </div>   

   

    <div class="postbox-container" id="side-container" style="width:24%;margin-left:1%">
            <div class="postbox">
                <h3 style="padding:8px;"><label><?php _e('Share the love','Dilemma'); ?></label></h3>
                <div class="inside">
                	<p>This plugin has been developed with love & effort, it's a work in progress and I really appreciate all of the contribution you guys make to it. Thank you!</p>
                	
                    <!-- <a href="codecanyon.net/item/social-gallery-wordpress-photo-viewer-plugin/2665332?ref=stormgate" target="_blank">Rate it 5 stars on Code Canyon</a><br /> -->
                  
                    <div  style="text-align:center;margin-top:12px"><strong>Share Dilemma:</strong></div>
                    <div class="socialGalleryShareBox">
	                    <a href="http://www.facebook.com/sharer.php?s= 100&amp;p[title]=Dilemma - The Ultimate Yes or No WordPress Plugin&amp;p[url]=http://dilemmaplugin.com/&amp;p[summary]=Dilemmma helps you pose a series of A or B type questions to your website visitors. A Must Have plugin for all WordPress users."target="_blank"><img src="<?php echo plugins_url('/i/fbshare.png',__FILE__); ?>" alt="" title="Share on Facebook" /></a>
	        	     	<a href="http://twitter.com/home?status=I Recommend You Dilemma for WordPress!! http://dilemmaplugin.com/" target="_blank"><img src="<?php echo plugins_url('/i/tweet.png',__FILE__); ?>" alt="" title="Share this on Twitter" /></a>
					 	<a href="http://www.linkedin.com/shareArticle?mini=true&url=http://dilemmaplugin.com/&title=Dilemma for WordPress&source=Dilemma" target="_blank"><img src="<?php echo plugins_url('/i/linkedin.png',__FILE__); ?>" alt="" title="Share this on LinkedIn" /></a>
						<a href="https://plus.google.com/share?url=http://dilemmaplugin.com/" target="_blank"><img src="<?php echo plugins_url('/i/gp.png',__FILE__); ?>" alt="" title="Share this on Google+1" /></a>
         			</div>
                </div>
            </div>
   </div>

   <div class="postbox-container" id="side-container" style="width:24%;margin-left:1%">
            <div class="postbox">
                <h3 style="padding:8px;"><label><?php _e('Other Plugins','PicsMash'); ?></label></h3>
                <div class="inside">
					<table>
						<tr>
							<td><a href = "http://codecanyon.net/item/wpeddit-reddit-for-wordpress/4053648?ref=mikemayhem3030" target = "_blank"><img src = "http://2.s3.envato.com/files/48455291/wpeddit-thumb.jpg"/></a></td>
							<td style = "padding:3px"><a href = "http://codecanyon.net/item/wpeddit-reddit-for-wordpress/4053648?ref=mikemayhem3030" target = "blank">WPeddit</a> turn your WordPress website into Reddit!
								</td>
						</tr>
						<tr>
							<td><a href = "http://epicplugins.com/external-url-link-to-featured-images/"><img src = "http://epicplugins.com/wp-content/uploads/2013/02/rsz_256.png"/></a></td>
							<td style = "padding:3px"><a href = "http://epicplugins.com/external-url-link-to-featured-images/">Link 2 Featured Image</a> set your featured image from an external URL.</td>
						</tr>
					</table>
                </div>
            </div>
	 
	 <div style = 'clear:both'></div>
	 
	 </div>
   <?php
}

#} RSS longevity
function dilemma_feedCache(){
	return 86400;	
}



#} Retrieves updated news.
function dilemma_retrieveNews(){

				global $tweety_urls;
                include_once(ABSPATH . WPINC . '/feed.php');
                add_filter( 'wp_feed_cache_transient_lifetime' , 'dilemma_feedCache' );
				$url = 'http://dilemmaplugin.com/feed/';
                $rss = fetch_feed($url);
                remove_filter( 'wp_feed_cache_transient_lifetime' , 'dilemma_feedCache' );
                
                if (!is_wp_error( $rss ) ) {
					
					$maxitems = $rss->get_item_quantity(5); 
                    $rss_items = $rss->get_items(0, $maxitems); 
					
				} ?>
                
                <ul>
                    <?php 
					if ($maxitems == 0) 
						echo '<li>No News (is this good news?)</li>';
                    else 
						foreach ( $rss_items as $item ) : ?>
                    <li>
                        <a href='<?php echo esc_url( $item->get_permalink() ); ?>' target = '_blank'
                        title='<?php echo 'Posted '.$item->get_date('j F Y | g:i a'); ?>'>
                        <?php echo  $item->get_title() ; ?></a><br/>
                        <?php echo  $item->get_description() ; ?>
                    </li>
                    <?php endforeach; ?>
                </ul>
                
                <?php
	
}


#} Options page
function dilemma_menu() {
    
    global $wpdb, $dilemma_urls, $dilemma_version,$dilemma_slugs;    #} Req
    // add database pointer
    
    if (!current_user_can('manage_options'))  {
        wp_die( __('You do not have sufficient permissions to access this page.','Dilemma') );
    }
    ?>
    <div id="sgpBod">
       <div class='myslogo'><?php echo '<img src="' .plugins_url( 'i/dilemmalogo.png' , __FILE__ ). '" > ';   ?></div>

            
            <?php dilemma_header(); ?>
            
            <?php dilemma_checkForMessages(); ?>

			<?php dilemma_pages_home(); ?>



	</div>
<?php
}
add_action( 'wp_ajax_nopriv_dilemma_vote', 'dilemma_vote' );
add_action( 'wp_ajax_dilemma_vote', 'dilemma_vote' );

function dilemma_vote(){
	global $wpdb;
	$wpdb->dil_ip   = $wpdb->prefix . 'dil_ip';
	
	$IP = get_option('dilIP');
	if($IP == 'yes'){
		$postid = (int)$_POST['postid'];	
		$ip	= "'".$_SERVER['REMOTE_ADDR']."'";
		$query = "SELECT dil_id FROM $wpdb->dil_ip WHERE dil_ip = $ip AND dil_id = $postid";
		$al = $wpdb->get_var( $wpdb->query($query) );
		if($al == NULL){
			$query = "INSERT INTO $wpdb->dil_ip ( dil_id , dil_ip ) VALUES ( $postid, $ip )";
			$wpdb->query($query);
		}
	}
	
	$win = $_POST['winner'];
	$postid = (int)$_POST['postid'];

	if(isset($win) && $win == 'A'){
	$w = 'winA';
	}elseif(isset($win) && $win == 'B'){
	$w = 'winB';
	}
	else{
	echo "Something isn't set";
	}
	
	if($win == 'A'){
	$vo = get_post_meta($postid,'winA',true);
	$vn = $vo + 1;
	update_post_meta($postid,'winA',$vn);
	$vn = get_post_meta($postid,'winA',true);
	}

	if($win == 'B'){
	$vo = get_post_meta($postid,'winB',true);
	$vn = $vo + 1;
	update_post_meta($postid,'winB',$vn);
	$vn = get_post_meta($postid,'winB',true);
	}
	


    $winA = get_post_meta($postid,'winA',true);
	$winB = get_post_meta($postid,'winB',true);
	$tot = $winA + $winB;
	update_post_meta($postid,'dil_total',$tot);
	
	$response = array();
	
	$wins = $winA + $winB;
	if($wins == 0){
		$percA = 0;
		$percB = 0;
		}
	else{
		$percA = 100*($winA/$wins);
		$percA = round($percA);
		$percB = 100 - $percA;
	}
	
	$response['votes'] = $wins;
	$response['percA'] = $percA;
	$response['percB'] = $percB;
	$response['winA']  = $winA;
	$response['winB']  = $winB;
    
    echo json_encode($response);
  
	// IMPORTANT: don't forget to "exit"
	exit;
}

function dilemma_header(){

    global $dilemma_urls;
    ?>
     
    <div id="fb-root"></div>
    <script>(function(d, s, id) {
      var js, fjs = d.getElementsByTagName(s)[0];
      if (d.getElementById(id)) return;
      js = d.createElement(s); js.id = id;
      js.src = "//connect.facebook.net/en_GB/all.js#xfbml=1&appId=438275232886336";
      fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));</script>

    <?php
    //build the twitter text tweet
        $URL = $dilemma_urls['home'];
        $siteURL = get_site_url();
        $PicsM = "http://dilemmaplugin.com/";
        $text = "I love " . $PicsM;
        $hash = "#dilemma";
        $QP = "?url=".$URL."&text=".$text."&hashtags=".$hash;
    ?>
    
	
	
    <?php

        $img = "http://3.s3.envato.com/files/40545636/dilemmapreview.jpg";
        echo "<a href='http://pinterest.com/pin/create/button/?url=$URL&media=$img&description=Description' class='pin-it-button' count-layout='horizontal'><img border'0' src='//assets.pinterest.com/images/PinExt.png' title='Pin It' /></a>";
    ?>

    <div class="fb-like" data-href="http://dilemmaplugin.com/" data-send="true" data-width="360" data-show-faces="false" data-font="arial"></div>

    <?php
	$home = $dilemma_urls['home'];
	$docs = $dilemma_urls['docs'];
	$forum =$dilemma_urls['forum'];
	$subs = $dilemma_urls['subscribe'];
        echo "<div id = 'ps-links' style = 'padding-top:1%;padding-bottom:1%'><ul style = 'display:inline'>
        <li style = 'display:inline;padding-right:1%'><a href = '$home'>dilemmaplugin.com</a></li>
        <li style = 'display:inline;padding-right:1%'><a href = '$docs'>Documentation</a></li>
        <li style = 'display:inline;padding-right:1%'><a href = '$forum'>Support Forum</a></li>
        <li style = 'display:inline;padding-right:1%'><a href = '$subs'>Subscribe to the EPIC mailing list</a></li>
        <li style = 'display:inline;padding-right:1%'><a href='mailto:mikemayhem3030@gmail.com?Subject=Hi%20Mike You Rock!'>Contact the developer</a></li>
        </ul></div>";



}



#} Outputs HTML message
function dilemma_html_msg($flag,$msg,$includeExclaim=false){
    
    if ($includeExclaim){ $msg = '<div id="sgExclaim">!</div>'.$msg.''; }
    
    if ($flag == -1){
        echo '<div class="sgfail wrap">'.$msg.'</div>';
    }
    if ($flag == 0){ ?>
        <div id="message" class="updated fade below-h2"><p><strong>Settings saved!</strong></p></div>
    <?php }
    if ($flag == 1){
        echo '<div class="sgwarn wrap">'.$msg.'</div>';
    }
    if ($flag == 2){
        echo '<div class="sginfo wrap">'.$msg.'</div>';
    }
    if ($flag == 666){ ?>
        <div id="message" class="updated fade below-h2"><p><strong><?php echo $msg; ?>!</strong></p></div>
    <?php }
}




function dilemma_short( $atts ) {
	extract( shortcode_atts( array(
		'author' => 'true',
		'cats' => 'true',
	), $atts ) );
    
    global $wp_query,$paged,$post,$wp,$wpdb;
    $wpdb->dil_ip   = $wpdb->prefix . 'dil_ip';
	$ip	= "'".$_SERVER['REMOTE_ADDR']."'";
	
	$querystr = "SELECT dil_id FROM $wpdb->dil_ip WHERE dil_ip = $ip ORDER BY dil_id";
    $added = $wpdb->get_col($querystr);
	if($added != NULL){
    	$str = implode(',', $added);
	}else{
		$str = 0;
	}
    $content = null;
    
    ob_start();
    echo "<br/>";
    //code will post form via AJAX
 
    
    ?>
    
    <script>var random = 'yes';</script>
	
	<div class = 'dil_wrap'>
	
    <div class = 'dilemma'>
    <?php $i = 0;

	$taxonomy = "'dilemma-cats'";
	$post_status = "'publish'";
	$post_type = "'dilemma'";

	$IP = get_option('dilIP');

    if($IP == 'yes'){
	$query = "SELECT * FROM $wpdb->posts WHERE post_type = 'dilemma' AND ID NOT IN ($str) AND post_status = 'publish' ORDER BY RAND() LIMIT 0,1";
	}else{
	$query = "SELECT * FROM $wpdb->posts WHERE post_type = 'dilemma' AND post_status = 'publish' ORDER BY RAND() LIMIT 0,1";	
	}
	
	if($author == 'true' && $cats != 'true'){
		if($IP == 'yes'){
		$query = "SELECT $wpdb->posts.* FROM $wpdb->posts
				  INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id)
				  INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id)
				  WHERE 1=1
				  AND $wpdb->term_taxonomy.taxonomy = $taxonomy
				  AND $wpdb->term_taxonomy.term_id = $cats
				  AND $wpdb->posts.post_type = $post_type
				  AND $wpdb->posts.ID NOT IN ($str)
				  AND $wpdb->posts.post_status = $post_status
				  GROUP BY $wpdb->posts.ID
				  ORDER BY RAND() LIMIT 0,1";
		}else{
		$query = "SELECT $wpdb->posts.* FROM $wpdb->posts
				  INNER JOIN $wpdb->term_relationships ON ($wpdb->posts.ID = $wpdb->term_relationships.object_id)
				  INNER JOIN $wpdb->term_taxonomy ON ($wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id)
				  WHERE 1=1
				  AND $wpdb->term_taxonomy.taxonomy = $taxonomy
				  AND $wpdb->term_taxonomy.term_id = $cats
				  AND $wpdb->posts.post_type = $post_type
				  AND $wpdb->posts.post_status = $post_status
				  GROUP BY $wpdb->posts.ID
				  ORDER BY RAND() LIMIT 0,1";
		}
	}

	elseif($cats == 'true' && $author != 'true'){
		if($IP == 'yes'){
			$query = "SELECT * FROM $wpdb->posts WHERE post_type = 'dilemma' AND ID NOT IN ($str) AND post_status = 'publish' AND post_author = $author ORDER BY RAND() LIMIT 0,1";		
		}else{
			$query = "SELECT * FROM $wpdb->posts WHERE post_type = 'dilemma' AND post_status = 'publish' AND post_author = $author ORDER BY RAND() LIMIT 0,1";
		}
	}elseif($cats == 'true' && $author == 'true'){
		
	}else{
	echo "You can only filter by either author or category";
	die();
	}	

	$IP = get_option('dilIP');
	$dilemmas = $wpdb->get_results($query);

    foreach($dilemmas as $dilemma){

	    $postid = $dilemma->ID;	
		$winA = get_post_meta($dilemma->ID,'winA',true);
		$winB = get_post_meta($dilemma->ID,'winB',true);
		$dilA = get_post_meta($dilemma->ID,'dilA',true);
		$dilB = get_post_meta($dilemma->ID,'dilB',true);
		
		$cleft = get_post_meta($dilemma->ID,'cleft',true);
		$cright = get_post_meta($dilemma->ID,'cright',true);
		
		if($cleft == 'image'){
			$image1 = get_post_meta($dilemma->ID,'image1',true);	
		}
		if($cright == 'image'){
			$image2 = get_post_meta($dilemma->ID,'image2',true);
		}
		
		//handle backwards compatibility
		if($cleft == ""){
			$cleft = 'blue';	
		}
		
		if($cright == ""){
			$cright = 'red';
		}	
			
		$winA = (double)$winA;
		$winB = (double)$winB;

		$wins = $winA + $winB;
		$wins = (double)$wins;
		
		if($wins == 0){
		$percA = 0;
		$percB = 0;
		}
		else{
		$percA = 100*($winA/$wins);
		$percA = round($percA);
		$percB = 100 - $percA;
		}

    }

        
    ?>

   <script src="http://malsup.github.com/jquery.form.js"></script>
   
	<?php if($dilemmas == NULL){
		$url = get_bloginfo('url');
		echo "You have answered all the Dilemmas on this site: <a href = '$url/dilemma/'>view results</a>";
	}else{ ?>
  
 	<div class = 'choice' data-choice = 'left'>
  		<div id = 'dilemmaleft<?php echo $postid?>' class = 'leftchoice dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = <?php echo $postid ?> data-choice = 'left' <?php if($cleft == 'image'){?> style = "background-image: url(<?php echo $image1;?>);" <?php } ?>>

            <form action = 'dilemma_vote' method = 'post' id = 'dilemma_leftform<?php echo $postid?>'>
 		<input type="hidden" name = "winner" value = "A" />
		<input type="hidden" name = "postid" value = "<?php echo $postid; ?>" />
                <div class = 'dil_option' id = 'dil_option<?php echo $postid?>l' data-id = '<?php echo $postid ?>'>
                <?php echo $dilA; ?>
                </div>
            </form>
        </div>
    
		 <?php if($cleft == 'image'){ ?>	 	
	<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = 'res' data-choice = 'left' style = "display:none;background-image: url(<?php echo $image1;?>);">
		 <?php }else{ ?>
	<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = 'res' data-choice = 'left' style = "display:none">		 	
		 <?php } ?>

                <div class = 'dil_res'>
                <span class = 'percentage' id = 'percA<?php echo $postid?>'><?php echo $percA . "%"; ?></span>
		<div id = 'leftnumview<?php echo $postid?>' class = 'agreeres'><span id = 'leftview<?php echo $postid?>'><?php echo number_format((double)$winA,0); ?><?php if($added != NULL){ echo _n( " vote", " votes", number_format((double)$winA,0), 'Dilemma' ); }?></span></div>
		<br/>
		<div id = 'dilleft' class = 'dil'><?php echo $dilA; ?></div>
		
                </div>
        </div>
   </div>        
        <div id = 'dilor'>
        	<p><?php _e( 'or', 'Dilemma' ) ?></p>
        </div>   
      <div class = 'choice' data-choice = 'right'> 
        <div id = 'dilemmaright<?php echo $postid?>' class = 'rightchoice dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = <?php echo $postid ?> data-choice = 'right'  <?php if($cright == 'image'){?> style = "background-image: url(<?php echo $image2;?>);" <?php } ?>>
            <form action = 'dilemma_vote' method = 'post' id = 'dilemma_rightform<?php echo $postid?>'>
                <input type="hidden" name = "winner" value = "B" />
		        <input type="hidden" name = "postid" value = "<?php echo $postid; ?>" />
                <div class = 'dil_option' id = 'dil_option<?php echo $postid?>r' data-id = '<?php echo $postid ?>'>
                <?php echo $dilB; ?>
                </div>
            </form>
        </div>
 
	 <?php if($cright == 'image'){ ?>
		 <div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = 'res' data-choice = 'right' style = 'display:none;background-image: url(<?php echo $image2;?>)'>
	 <?php }else{ ?>
	 	<div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = 'res' data-choice = 'right' style = 'display:none'>
	 <?php } ?>
          <div class = 'dil_res'>
                <span class = 'percentage' id = 'percB<?php echo $postid?>'><?php echo $percB . "%"; ?></span>
		<div id = 'rightnumview<?php echo $postid?>' class = 'agreeres'><span id = 'rightview<?php echo $postid?>'><?php echo number_format((double)$winB,0); ?><?php if($added != NULL){ echo _n( " vote", " votes", number_format((double)$winB,0), 'Dilemma' ); }?></span></div>
		<br/>
		<div id = 'dilright' class = 'dil'><?php echo $dilB; ?></div>
		
		
		
          </div>
        </div>

</div>



    </div>
    <div class = 'random_dil'><div id = 'dilcounter'>
    <?php
    if(get_option("diltimer") == 'no'){?>
    <a href = "#" class = "button" onclick = "window.location.reload(1)">Next Dilemma</a>	
    <?php }  ?>
    </div>


<?php
if(get_option("diltimer") == 'yes'){
    	?>
<script>
jQuery(document).ready(function($) {
	ss = 10;	
	updateWCTime = function() {
     $("#dilcounter").html('Next dilemma in ' + ss + ' seconds');
     ss = ss - 1;
     if(ss == 0){
     	ss = 5;
     	window.location.reload(1);
     }
	}
	setInterval('updateWCTime()', 1000 );
});
</script>
<?php
	}
?>

<?php } ?>
    </div>    </div>
    

    
    <?php
    $content = ob_get_contents();
    ob_end_clean();
    return $content;
}
add_shortcode("dilemma", "dilemma_short");

function single_dil( $atts ) {
	extract( shortcode_atts( array(
		'dil' => 'true',
	), $atts ) );
    
    global $wp_query,$paged,$post,$wp,$wpdb;
    $wpdb->dil_ip   = $wpdb->prefix . 'dil_ip';
	$ip	= "'".$_SERVER['REMOTE_ADDR']."'";
	

    $content = null;
    
    ob_start();



    ?>
	
	<div class = 'dil_wrap'>
	
    <div class = 'dilemma'>
    <?php $i = 0;

	$taxonomy = "'dilemma-cats'";
	$post_status = "'publish'";
	$post_type = "'dilemma'";

	$IP = get_option('dilIP');
	$added = NULL; 
	$query = "SELECT * FROM $wpdb->posts WHERE ID = $dil AND post_status = 'publish'";	
	if($IP == 'yes'){
	$querystr = "SELECT dil_id FROM $wpdb->dil_ip WHERE dil_ip = $ip AND dil_id = $dil";
    $added = $wpdb->get_col($querystr);
	}
	$dilemmas = $wpdb->get_results($query);

    foreach($dilemmas as $dilemma){

	    $postid = $dilemma->ID;	
		$winA = get_post_meta($dilemma->ID,'winA',true);
		$winB = get_post_meta($dilemma->ID,'winB',true);
		$dilA = get_post_meta($dilemma->ID,'dilA',true);
		$dilB = get_post_meta($dilemma->ID,'dilB',true);
		
		$cleft = get_post_meta($dilemma->ID,'cleft',true);
		$cright = get_post_meta($dilemma->ID,'cright',true);
		
		if($cleft == 'image'){
			$image1 = get_post_meta($dilemma->ID,'image1',true);	
		}
		if($cright == 'image'){
			$image2 = get_post_meta($dilemma->ID,'image2',true);
		}
		
		if($cleft == ""){
			$cleft = 'blue';	
		}
		
		if($cright == ""){
			$cright = 'red';
		}	
		
				
		$winA = (double)$winA;
		$winB = (double)$winB;

		$wins = $winA + $winB;
		$wins = (double)$wins;
		
		if($wins == 0){
		$percA = 0;
		$percB = 0;
		}
		else{
		$percA = 100*($winA/$wins);
		$percA = round($percA);
		$percB = 100 - $percA;
		}

    }

        
    ?>

   <script src="http://malsup.github.com/jquery.form.js"></script>
   
  	
  	<div class = 'choice' data-choice = 'left'>
  		<?php if($added != NULL && $IP == 'yes'){ ?>
  		<div id = 'dilemmaleft<?php echo $postid?>' class = 'leftchoice leftchoiceclicked clicky dil<?php echo $cleft;?>' data-id = <?php echo $postid ?> data-choice = 'left' style = 'display:none' data-dil-clicked = 'yes'>
  		<?php }else{ ?>
        <div id = 'dilemmaleft<?php echo $postid?>' class = 'leftchoice dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = <?php echo $postid ?> data-choice = 'left' <?php if($cleft == 'image'){?> style = "background-image: url(<?php echo $image1;?>);" <?php } ?>>
        <?php } ?>
            <form action = 'dilemma_vote' method = 'post' id = 'dilemma_leftform<?php echo $postid?>' class = 'dil_form'>
 		<input type="hidden" name = "winner" value = "A" />
		<input type="hidden" name = "postid" value = "<?php echo $postid; ?>" />
                <div class = 'dil_option' id = 'dil_option<?php echo $postid?>l' data-id = '<?php echo $postid ?>'>
                <?php echo $dilA; ?>
                </div>
            </form>
        </div>
    
    <?php if($added != NULL && $IP == 'yes'){ ?>
    	<?php if($cleft == 'image'){ ?>	
			<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice leftchoiceclicked clicky dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = 'res'  data-choice = 'left' data-dil-clicked = 'yes' style = "background-image: url(<?php echo $image1;?>);">
		<?php }else{ ?>
			<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice leftchoiceclicked clicky dil<?php echo $cleft;?>' data-id = 'res'  data-choice = 'left' data-dil-clicked = 'yes'>	
		<?php } ?>
			
	<?php }else{ ?>
		 <?php if($cleft == 'image'){ ?>	 	
	<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = 'res' data-choice = 'left' style = "display:none;background-image: url(<?php echo $image1;?>);">
		 <?php }else{ ?>
	<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice dil<?php echo $cleft;?> dil<?php echo $cleft;?>-left' data-id = 'res' data-choice = 'left' style = "display:none">		 	
		 <?php } ?>
	
	<?php } ?>
                <div class = 'dil_res'>
                <span class = 'percentage'  id = 'percA<?php echo $postid?>'><?php echo $percA; ?>%</span>
		<div id = 'leftnumview' class = 'agreeres'><span id = 'leftview<?php echo $postid?>'><?php echo $winA; ?><?php if($added != NULL){ echo _n( " vote", " votes", $winA, 'Dilemma' ); }?></span></div>
		<br/>
		<div id = 'dilleft' class = 'dil'><?php echo $dilA; ?></div>
                </div>
        </div>
 	  </div>
        <div id = 'dilor'>
        	<p><?php _e( 'or', 'Dilemma' ) ?></p>
        </div> 
      <div class = 'choice' data-choice = 'right'> 
      	<?php if($added != NULL && $IP == 'yes'){ ?>
      	    	<?php if($cright == 'image'){ ?>		
        		<div id = 'dilemmaright<?php echo $postid?>' class = 'rightchoice rightchoiceclicked clicky dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = <?php echo $postid ?> data-choice = 'right'  data-dil-clicked = 'yes' style = "display:none;background-image: url(<?php echo $image2;?>);">
        		<?php }else{ ?>
        		<div id = 'dilemmaright<?php echo $postid?>' class = 'rightchoice rightchoiceclicked clicky dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = <?php echo $postid ?> data-choice = 'right' style = 'display:none' data-dil-clicked = 'yes'>      			
				<?php } ?>        			
        			
        <?php }else{ ?>
         <div id = 'dilemmaright<?php echo $postid?>' class = 'rightchoice dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = <?php echo $postid ?> data-choice = 'right'  <?php if($cright == 'image'){?> style = "background-image: url(<?php echo $image2;?>);" <?php } ?>>
         <?php } ?>
            <form action = 'dilemma_vote' method = 'post' id = 'dilemma_rightform<?php echo $postid?>' class = 'dil_form'>
                <input type="hidden" name = "winner" value = "B" />
		        <input type="hidden" name = "postid" value = "<?php echo $postid; ?>" />
                <div class = 'dil_option' id = 'dil_option<?php echo $postid?>r' data-id = '<?php echo $postid ?>'>
                <?php echo $dilB; ?>
                </div>
            </form>
        </div>
    <?php if($added != NULL && $IP == 'yes'){ ?>    
	<div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice rightchoiceclicked clicky dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = 'res'  data-choice = 'right' data-dil-clicked = 'yes' style = "background-image: url(<?php echo $image2;?>);">
	 <?php }else{ ?>
	 <?php if($cright == 'image'){ ?>
		 <div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = 'res' data-choice = 'right' style = 'display:none;background-image: url(<?php echo $image2;?>)'>
	 <?php }else{ ?>
	 	<div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice dil<?php echo $cright;?> dil<?php echo $cright;?>-right' data-id = 'res' data-choice = 'right' style = 'display:none'>
	 <?php } ?>
	 <?php } ?>
                <div class = 'dil_res'>
                <span class = 'percentage'  id = 'percB<?php echo $postid?>'><?php echo $percB; ?>%</span>
		<div id = 'rightnumview' class = 'agreeres'><span id = 'rightview<?php echo $postid?>'><?php echo $winB; ?><?php if($added != NULL){ echo _n( " vote", " votes", $winB, 'Dilemma' ); }?></span></div>
		<br/>
		<div id = 'dilright' class = 'dil'><?php echo $dilB; ?></div>
		
		
		
          </div>
        </div>

</div>



</div>
</div> 
    

    
    <?php
    $content = ob_get_contents();
    ob_end_clean();
    return $content;
}

add_shortcode("dil", "single_dil");

function single_dil_s( $atts ) {
	extract( shortcode_atts( array(
		'dil' => 'true',
	), $atts ) );
    
    global $wp_query,$paged,$post,$wp,$wpdb;
    $wpdb->dil_ip   = $wpdb->prefix . 'dil_ip';
	$ip	= "'".$_SERVER['REMOTE_ADDR']."'";
	

    $content = null;
    
    ob_start();



    ?>
	
	<div class = 'dil_wrap_min'>
	
   
    <?php $i = 0;

	$taxonomy = "'dilemma-cats'";
	$post_status = "'publish'";
	$post_type = "'dilemma'";

	$IP = get_option('dilIP');
	$added = NULL; 
	$query = "SELECT * FROM $wpdb->posts WHERE ID = $dil AND post_type = 'dilemma' AND post_status = 'publish'";	
	if($IP == 'yes'){
	$querystr = "SELECT dil_id FROM $wpdb->dil_ip WHERE dil_ip = $ip AND dil_id = $dil";
    $added = $wpdb->get_col($querystr);
	}
	$dilemmas = $wpdb->get_results($query);

    foreach($dilemmas as $dilemma){

	    $postid = $dilemma->ID;	
		$winA = get_post_meta($dilemma->ID,'winA',true);
		$winB = get_post_meta($dilemma->ID,'winB',true);
		$dilA = get_post_meta($dilemma->ID,'dilA',true);
		$dilB = get_post_meta($dilemma->ID,'dilB',true);
		
		$winA = (double)$winA;
		$winB = (double)$winB;
		
		
		$votes = $winA + $winB;
		$votes = (double)$votes;

		$wins = $winA + $winB;
		if($wins == 0){
		$percA = 0;
		$percB = 0;
		}
		else{
		$percA = 100*($winA/$wins);
		$percA = round($percA);
		$percB = 100 - $percA;
		}

    }

        
    ?>

   <script src="http://malsup.github.com/jquery.form.js"></script>
  
  <div class = 'dil_title'>
    <?php echo get_the_title($postid) ?>
  </div>
  
  <div class = 'dilemma'>
  	<div class = 'choice' data-choice = 'left'>
  		<?php if($added != NULL && $IP == 'yes'){ ?>
  		<div id = 'dilemmaleft<?php echo $postid?>' class = 'leftchoice' data-id = <?php echo $postid ?> data-choice = 'left' style = 'display:none'>
  		<?php }else{ ?>
        <div id = 'dilemmaleft<?php echo $postid?>' class = 'leftchoice' data-id = <?php echo $postid ?> data-choice = 'left'>
        <?php } ?>
            <form action = 'dilemma_vote' method = 'post' id = 'dilemma_leftform<?php echo $postid?>' class = 'dil_form'>
 		<input type="hidden" name = "winner" value = "A" />
		<input type="hidden" name = "postid" value = "<?php echo $postid; ?>" />
                <div class = 'dil_option' id = 'dil_option<?php echo $postid?>l' data-id = '<?php echo $postid ?>'>
                <?php echo $dilA; ?>
                </div>
            </form>
        </div>
    
    <?php if($added != NULL && $IP == 'yes'){ ?>
	<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice' data-id = 'res'  data-choice = 'left'>
	<?php }else{ ?>
	<div id = 'dilemmaleftres<?php echo $postid?>' class = 'leftchoice' data-id = 'res' style = 'display:none' data-choice = 'left'>
	<?php } ?>
                <div class = 'dil_res'>
                <span class = 'percentage' id = 'percA<?php echo $postid?>'><?php echo $percA; ?>%</span>
	<br/><br/>

		
                </div>
        </div>
   </div>
        
        <div id = 'dilor'>
        	<p><?php _e( 'or', 'Dilemma' ) ?></p>
        </div>
      
      <div class = 'choice' data-choice = 'right'> 
      	<?php if($added != NULL && $IP == 'yes'){ ?>
        <div id = 'dilemmaright<?php echo $postid?>' class = 'rightchoice' data-id = <?php echo $postid ?> data-choice = 'right' style = 'display:none'>
        <?php }else{ ?>
         <div id = 'dilemmaright<?php echo $postid?>' class = 'rightchoice' data-id = <?php echo $postid ?> data-choice = 'right' >
         <?php } ?>
            <form action = 'dilemma_vote' method = 'post' id = 'dilemma_rightform<?php echo $postid?>' class = 'dil_form'>
                <input type="hidden" name = "winner" value = "B" />
		        <input type="hidden" name = "postid" value = "<?php echo $postid; ?>" />
                <div class = 'dil_option' id = 'dil_option<?php echo $postid?>r' data-id = '<?php echo $postid ?>'>
                <?php echo $dilB; ?>
                </div>
            </form>
        </div>
    <?php if($added != NULL && $IP == 'yes'){ ?>    
	<div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice' data-id = 'res'  data-choice = 'right'>
	 <?php }else{ ?>
	 <div id = 'dilemmarightres<?php echo $postid?>' class = 'rightchoice' data-id = 'res' data-choice = 'right' style = 'display:none'>
	 <?php } ?>
                <div class = 'dil_res'>
                <span class = 'percentage' id = 'percB<?php echo $postid?>'><?php echo $percB; ?>%</span>
			<br/><br/>
		
		
		
      </div>
   </div>

</div>



    </div>
    
    <div><?php echo _n( " vote", " votes", $votes, 'Dilemma' ); ?>: <i><span class = 'votes' id = 'votes_dil<?php echo $postid?>' data-id = <?php echo $postid ?>><?php echo number_format((double)$votes,0); ?></span></i></div>
    

    </div>
    

    
    <?php
    $content = ob_get_contents();
    ob_end_clean();
    return $content;
}

add_shortcode("dil_mini", "single_dil_s");



add_filter( 'manage_edit-dilemma_columns', 'my_edit_dilemma_columns' ) ;

function my_edit_dilemma_columns( $columns ) {

    $columns = array(
        'cb' => '<input type="checkbox" />',
        'title' => __( 'Title','Dilemma' ),	
        'id' => __( 'ID','Dilemma'),
        'A' => __( 'A','Dilemma' ),
        'B' => __( 'B','Dilemma' ),
        'winA' => __( 'A Votes','Dilemma' ),
        'winB' => __( 'B Votes','Dilemma' ),
        'total' => __( 'Total Votes','Dilemma' ),
	    'author' => __('Author','Dilemma'),
        'date' => __( 'Date','Dilemma' )
    );

    return $columns;
}

add_action( 'manage_dilemma_posts_custom_column', 'my_manage_dilemma_columns', 10, 2 );

function my_manage_dilemma_columns( $column, $post_id ) {
    global $post;

    switch( $column ) {

        /* If displaying the 'rating' column. */
            case 'A' :

            /* Get the post meta. */
            $dilA = get_post_meta($post_id,'dilA',true);
            echo $dilA;

            break;
			
			 case 'id' :

            /* Get the post meta. */
            echo $post_id;

            break;
        
        
		   case 'B' :

            /* Get the post meta. */
            $dilB = get_post_meta($post_id,'dilB',true);
            echo $dilB;

            break;
            
		  case  'winA':		             
            echo get_post_meta($post_id,'winA',true);
		  break;
		  
		  case 'winB':
			echo get_post_meta($post_id,'winB',true);
		  break;

		  case 'total':
			$total = get_post_meta($post_id,'dil_total',true);
			echo $total;
		  break;
        /* Just break out of the switch statement for everything else. */
default:
            break;
    }
}


add_filter( 'manage_edit-dilemma_sortable_columns', 'my_dilemma_sortable_columns' );

function my_dilemma_sortable_columns( $columns ) {

    $columns['winA'] = 'winA';
    $columns['winB'] = 'winB';
    $columns['total'] = 'total';
    

    return $columns;
}


/* Only run our customization on the 'edit.php' page in the admin. */
add_action( 'load-edit.php', 'my_edit_dilemma_load' );

function my_edit_dilemma_load() {
    add_filter( 'request', 'my_sort_dilemma' );
}

/* Sorts the pics. */
function my_sort_dilemma( $vars ) {

    /* Check if we're viewing the 'picsmash' post type. */
    if ( isset( $vars['post_type'] ) && 'dilemma' == $vars['post_type'] ) {

        /* Check if 'orderby' is set to 'rating'. */
        if ( isset( $vars['orderby'] ) && 'winA' == $vars['orderby'] ) {

            /* Merge the query vars with our custom variables. */
            $vars = array_merge(
                $vars,
                array(
                    'meta_key' => 'winA',
                    'orderby' => 'meta_value_num'
                )
            );
        }
        
        if ( isset( $vars['orderby'] ) && 'winB' == $vars['orderby'] ) {

            /* Merge the query vars with our custom variables. */
            $vars = array_merge(
                $vars,
                array(
                    'meta_key' => 'winB',
                    'orderby' => 'meta_value_num'
                )
            );
        }
        
            if ( isset( $vars['orderby'] ) && 'total' == $vars['orderby'] ) {

            /* Merge the query vars with our custom variables. */
            $vars = array_merge(
                $vars,
                array(
                    'meta_key' => 'dil_total',
                    'orderby' => 'meta_value_num'
                )
            );
        }
    }

    return $vars;
}








//code for manually adding new

add_action( 'add_meta_boxes', 'dil_custom_meta_box' );

function dil_custom_meta_box() {
    add_meta_box( 'Dilemma', 'Dilemma', 'dil_rating_A', 'dilemma', 'normal', 'high' );
}

function dil_rating_A() {
    global $wp, $wpdb, $post;

    // Noncename needed to verify where the data originated
    echo '<input type="hidden" name="eventmeta_noncename" id="eventmeta_noncename" value="' .
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
    // Get the location data if its already been entered

    $dilA 	= 		get_post_meta($post->ID, 'dilA', true);
    $dilB 	= 		get_post_meta($post->ID, 'dilB', true);
    $winA 	= 		get_post_meta($post->ID, 'winA', true);
    $winB 	= 		get_post_meta($post->ID, 'winB', true);
	$cleft 	=     	get_post_meta($post->ID, 'cleft', true);
	$cright =     	get_post_meta($post->ID, 'cright', true);
	
	$image1 =		get_post_meta($post->ID,'image1',true);
	$image2 =		get_post_meta($post->ID,'image2',true);
		
    // Echo out the field
    
    $color_array = array();
	$color_array = array('red','blue','green','silver','image');
	?>
   <label>Image:</label><br/>
   <img id = "img1" class = 'img' src = "<?php echo $image1;?>" style = "max-height:200px;max-width:300px"/>
   <br/>
   <input id="dilemma1" type="text" name="image_location1" value="<?php echo $image1;?>" size="50" />
   <input  class="onetarek-upload-button button" type="button" value="Upload Image" data-prev = 'img1'/>
      <br/>
   <label>Question:</label><br/>
	<?php
	echo '<input type="text" name="dilA" value="' . $dilA  . '" size="50" />';
	?>
	<br/>
	Type: 
	<select name = "cleft">
	<?php foreach ($color_array as $v) {
			if($v == $cleft){
				echo "<option value = '$v' selected>$v</option>";
			}else{
				echo "<option value = '$v'>$v</option>";				
			}
		}
		?>
	</select>
	<?php
	echo '</br><div style = "font-size:24px;padding:10px;margin-top:30px">'; _e( 'or', 'Dilemma' ); echo '</div></br>';
	?>
	
   <label>Image:</label><br/>
   <img id = "img2" class = 'img' src = "<?php echo $image2;?>" style = "max-height:200px;max-width:300px"/>
   <br/>
   <input id="dilemma2" type="text" name="image_location2" value="<?php echo $image2;?>" size="50" />
   <input  class="onetarek-upload-button button img2" type="button" value="Upload Image" data-prev = 'img2'/>
   <br/>
   <label>Question:</label><br/>
	<?php
	echo '<input type="text" name="dilB" value="' . $dilB  . '" size = "50" />';
	?>
	<br/>
	Type: 
	<select name = "cright">
		<?php foreach($color_array as $v){
			if($v == $cright){
				echo "<option value = '$v' selected>$v</option>";
			}else{
				echo "<option value = '$v'>$v</option>";				
			}
		}
		?>
	</select>

<?php

    echo '<input type="hidden" name="winA" value="' . $winA  . '" class="widefat" />';
    echo '<input type="hidden" name="winB" value="' . $winB  . '" class="widefat" />';


}


// Save the Metabox Data
function wpt_save_dil_meta($post_id, $post) {

     global $wp, $wpdb;  
    
    // Is the user allowed to edit the post or page?
    if ( !current_user_can( 'edit_post', $post->ID ))
        return $post->ID;
    // OK, we're authenticated: we need to find and save the data
    // We'll put it into an array to make it easier to loop though.
    $dilA		 		= $_POST['dilA'];
    $dilB				= $_POST['dilB'];
    $winA	 			= $_POST['winA'];
    $winB	 			= $_POST['winB'];
	$image1				= $_POST['image_location1'];
	$image2				= $_POST['image_location2'];
	
	//for the color options
	
	$cleft			= $_POST['cleft'];
	$cright			= $_POST['cright'];

    update_post_meta($post->ID, 'dilA', $dilA);
    update_post_meta($post->ID, 'dilB', $dilB);
    update_post_meta($post->ID, 'winA', $winA);
    update_post_meta($post->ID, 'winB', $winB);
	
	//for the color options
    update_post_meta($post->ID, 'cleft', $cleft);
    update_post_meta($post->ID, 'cright', $cright);
	update_post_meta($post->ID,'image1',$image1);
	update_post_meta($post->ID,'image2',$image2);
    

}
add_action('save_post', 'wpt_save_dil_meta', 1, 2); // save the custom fields


add_filter( 'add_menu_classes', 'dil_show_pending_number');
function dil_show_pending_number( $menu ) {
    $type = "dilemma";
    $status = "pending";
    $num_posts = wp_count_posts( $type, 'readable' );
    $pending_count = 0;
    if ( !empty($num_posts->$status) )
        $pending_count = $num_posts->$status;

    // build string to match in $menu array
    if ($type == 'post') {
        $menu_str = 'edit.php';
    } else {
        $menu_str = 'edit.php?post_type=' . $type;
    }

    // loop through $menu items, find match, add indicator
    foreach( $menu as $menu_key => $menu_data ) {
        if( $menu_str != $menu_data[2] )
            continue;
        $menu[$menu_key][0] .= " <span class='update-plugins count-$pending_count'><span class='plugin-count'>" . number_format_i18n($pending_count) . '</span></span>';
    }
    return $menu;
}


add_action('wp_ajax_dil_upload_action', 'dil_ajax_upload');
add_action('wp_ajax_nopriv_dil_upload_action', 'dil_ajax_upload');

function dil_ajax_upload(){
	
global $current_user;
$author =  $current_user->ID;

//get POST data
    $title = $_POST['title'];
    $dilA = $_POST['dilA'];
	$dilB = $_POST['dilB'];
	    
	    $my_post = array(
	    'post_title' => $title,
	    'post_status' => 'pending',
	    'post_type' => 'dilemma',
	    'post_author' => $author,
	     );
                        
	     #} Insert the post into the database
	    $post_id = wp_insert_post( $my_post );

   
	    update_post_meta($post_id, 'dilA', $dilA);
	    update_post_meta($post_id, 'dilB', $dilB);
	    update_post_meta($post_id, 'winA', 0);
	    update_post_meta($post_id, 'winB',0);
    

  echo "<b>Thank You!</b> Your Dilemma has been added.";

  die();
} 


function dil_front_upload() {
    
    global $wp_query,$paged,$post,$wp,$wpdb;
    $content = null;
    
    ob_start();
    echo "<br/>";  
    
    
    
    ?>

	
	<form id="thumbnail_upload" method="post" action="dil_ajax_upload">

	  
	  <label>Dilemma!</label>
	  <input type="text" name="title" id = "title" style = "width:70%"></br>
	  <br/>
	  <input type="text" name="dilA" id = "dilA" class = 'dilformb' style = "width:70%"></br>
	   <label>Choice A</label><br/>
	   <input type="text" name="dilB" id = "dilB" class = 'dilformr' style = "width:70%"></br>
	   <label>Choice B</label><br/>
	  <input type="hidden" name="action" id="action" value="dil_upload_action">
	  <br/><br/>
	  <input id="submit-ajax" name="submit-ajax" type="submit" value="Add Dilemma">
	  <br/><br/>
	<form>
	
	<div id="ps_output"></div>
	<?php
	$link = admin_url('admin-ajax.php');
	?>
	<script>
	jQuery(document).ready(function() { 
	

	    var options = { 
	        target:        '#ps_output',      // target element(s) to be updated with server response 
	        beforeSubmit:  showRequest,     // pre-submit callback 
	        success:       showResponse,    // post-submit callback 
	        url:    	   '<?php echo $link; ?>'         // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php     
	    }; 
	
	    // bind form using 'ajaxForm' 
	    jQuery('#thumbnail_upload').ajaxForm(options); 
	});
	
	function showRequest(formData, jqForm, options) {
	//do extra stuff before submit like disable the submit button
	jQuery('#ps_output').html('Sending...');
	jQuery('#submit-ajax').attr("disabled", "disabled");
	}
	function showResponse(responseText, statusText, xhr, $form)  {
	//do extra stuff after submit
	jQuery('#submit-ajax').attr("enabled", "enabled");
	}
	</script>
    
    <?php
    $content = ob_get_contents();
    ob_end_clean();
    return $content;
    
}

add_shortcode("dilupload", "dil_front_upload");

//v2.0 updates

add_filter ('the_content', 'dillcontent');
function dillcontent($content) {
   global $wp, $wpdb, $post;
     
   ob_start();
	
   	 $type = get_post_meta($post->ID,'winA',true);

   	  if($post->post_type == 'dilemma'){
   	  echo do_shortcode("[dil dil = $post->ID ]");	
      }
   $content .= ob_get_contents();
    ob_end_clean();
   return $content;
}



#} Widgets
class dil_myo_widget extends WP_Widget {
    function dil_myo_widget() {
        parent::WP_Widget(false, $name = 'Dilemma Widget', array(
            'description' => 'Dilemma! Shows the total number of Dilemmas and the total number of votes.'
        ));
    }
    function widget($args, $instance) {
    	 global $wp_query,$paged,$post,$wp,$wpdb;
    	 $wpdb->dil_ip   = $wpdb->prefix . 'dil_ip';
	
        extract($args);$mode = (is_numeric($instance['mode']) ? (int)$instance['mode'] : 5);if (!empty($instance['target'])) $targetStr = ' target="'.$instance['target'].'"'; else $targetStr = '';
		if (!empty($instance['title'])) $title = $instance['title']; else $title = '';		
		if (!empty($instance['item'])) $item = $instance['item']; else $item = '';		
		
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		 $numposts = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->posts WHERE (post_status = 'publish' AND post_type = 'dilemma')");
 		 if (0 < $numposts) $numposts = number_format($numposts);
		
		$numvotes = $wpdb->get_var("SELECT COUNT(*) FROM $wpdb->dil_ip WHERE 1");
		


		echo $before_widget;

		
		
		$url = plugins_url('/i/dilwidget.png',__FILE__);
		$dil_link = get_option('dil_love');
		if($item == ''){
			$item = 'mikemayhem3030';
		}
		echo "<div class = 'dilwrapper'>";
		if($mode == 5){
		echo "<a href = 'http://codecanyon.net/item/dilemma-wordpress-plugin/3377683?ref=$item' target = '_blank' title = 'Dilemma Stats'><img src = '$url' /></a>"; //stuff inside the widget;
		}else{
		echo "<img src = '$url' title = 'Dilemma Stats' />"; //stuff inside the widget;	
		}
		
		$url = get_bloginfo('url');

		
		echo "<div class = 'dil_stats'><span class = 'rvotes'>". number_format((double)$numvotes,0) ."</span> votes on <span class = 'lvotes'>". number_format((double)$numposts,0) . "</span> Dilemmas on this website.</div>";
		echo "</div>";
		
		echo $after_widget;
		
    }
    function update($new_instance, $old_instance) {
        return $new_instance;
    }
    function form($instance) {
        if (isset($instance['mode'])) $mode = esc_attr($instance['mode']); else $mode = 5;
        if (isset($instance['target'])) $target = esc_attr($instance['target']); else $target = '';
		if (isset($instance['title'])) $title = esc_attr($instance['title']); else $title = '';
		if (isset($instance['item'])) $item = esc_attr($instance['item']); else $item = '';
        if (isset($instance['buttontext'])) $buttontext = esc_attr($instance['buttontext']); else $buttontext = ''; ?>
        	<p>


                <label for="<?php echo $this->get_field_id('item'); ?>">
                    CodeCanyon username:
                </label>
                <input id="<?php echo $this->get_field_id('item'); ?>" class="widefat" name="<?php echo $this->get_field_name('item'); ?>" value = "<?php echo $item; ?>"  />
                
                <label for="<?php echo $this->get_field_id('mode'); ?>">
                    Make 30% of sales by referring new people to Dilemma:
                </label>
                <select id="<?php echo $this->get_field_id('mode'); ?>" class="widefat" name="<?php echo $this->get_field_name('mode'); ?>">
   					<option value="5"<?php if ($mode == 5) echo ' selected="selected"'; ?>>yes</option>
                    <option value="10"<?php if ($mode == 10) echo ' selected="selected"'; ?>>no</option>
                </select>
                
            </p>
        	<?php
		
    }
}

add_action('widgets_init', 'dil_register_states_widget');
function dil_register_states_widget() {
    register_widget('dil_myo_widget');
}

//extra v2.0 goodness



#} Send registration info to my server
function dilemma_sendReg($e='',$na='',$pl=''){

			global $dilemma_urls, $dilemma_version;	
			if( function_exists('curl_init') ) { 
					$postData = array('ori'=>get_site_url());
					$postData['e'] = $e; //email
					$postData['na'] = $na;  //name
					$postData['pl'] = $pl;  //plugin

					
					$fields = ''; foreach($postData as $key => $value) $fields .= $key . '=' . $value . '&'; rtrim($fields, '&');
					$ch = curl_init($dilemma_urls['regCheck']);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_setopt($ch, CURLOPT_POST, count($postData));
					curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
					curl_setopt($ch, CURLOPT_TIMEOUT, 10);
					$regDets = curl_exec($ch);
					
					curl_close($ch);
					return $regDets;
			} # else, cry?			
			return  $false;
}



//code for the warnings and auto updating
$api_url = $dilemma_urls['updateCheck'];
$plugin_slug = basename(dirname(__FILE__));


// Take over the update check
add_filter('pre_set_site_transient_update_plugins', 'dilemma_check_for_plugin_update');

function dilemma_check_for_plugin_update($checked_data) {
	global $api_url, $plugin_slug;

	//Comment out these two lines during testing.
	if (empty($checked_data->checked))
		return $checked_data;

	$args = array(
		'slug' => $plugin_slug,
		'version' => $checked_data->checked[$plugin_slug .'/'. $plugin_slug .'.php'],
	);
	$request_string = array(
			'body' => array(
				'action' => 'basic_check', 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);

	// Start checking for an update
	$raw_response = wp_remote_post($api_url, $request_string);

	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);

	if (is_object($response) && !empty($response)) // Feed the update data into WP updater
		$checked_data->response[$plugin_slug .'/'. $plugin_slug .'.php'] = $response;

	return $checked_data;
}



add_filter('plugins_api', 'dilemma_plugin_api_call', 10, 3);

function  dilemma_plugin_api_call($def, $action, $args) {
	global $plugin_slug, $api_url;

	if ($args->slug != $plugin_slug)
		return false;

	// Get the current version
	$plugin_info = get_site_transient('update_plugins');
	$current_version = $plugin_info->checked[$plugin_slug .'/'. $plugin_slug .'.php'];
	$args->version = $current_version;

	$request_string = array(
			'body' => array(
				'action' => $action, 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);

	$request = wp_remote_post($api_url, $request_string);

	if (is_wp_error($request)) {
		$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>','Dilemma'), $request->get_error_message());
	} else {
		$res = unserialize($request['body']);

		if ($res === false)
			$res = new WP_Error('plugins_api_failed', __('An unknown error occurred','Dilemma'), $request['body']);
	}

	return $res;
}

add_action('wp_ajax_dil_upload_action_image', 'dil_ajax_upload_image_2');
add_action('wp_ajax_nopriv_dil_upload_action_image', 'dil_ajax_upload_image_2');

function dil_ajax_upload_image_2(){
	
global $current_user;
$author =  $current_user->ID;

//get POST data
    $title = $_POST['title'];
    $dilA = $_POST['dilA'];
	$dilB = $_POST['dilB'];
	$cat = $_POST['cat'];          //MS - this grabs the item from the form named 'cat' (see below)
	$taxonomy = 'dilemma-cats';   //MS - this is the taxonomy used in Dilemma.php file and needs to be set here before adding the terms [8 Sept 2013]
	
		    $my_post = array(
	    'post_title' => $title,
	    'post_status' => 'pending',
	    'post_type' => 'dilemma',
	    'post_author' => $author,
	     );
                        
	     #} Insert the post into the database
	    $post_id = wp_insert_post( $my_post );
		
		wp_set_post_terms( $post_id, $cat, $taxonomy);  //MS - this sets the category of the dilemma... which is read in from the upload form... (see below)
		
		update_post_meta($post_id, 'cleft', 'blue');
 	    update_post_meta($post_id, 'cright', 'red');
	
	
	if ($_FILES) {
		$i = 1;
        foreach ($_FILES as $file => $array) {
            if ($_FILES[$file]['error'] !== UPLOAD_ERR_OK) {
                if($_FILES['fileA']['size'] == 0){
                	
                }else{
                	update_post_meta($post_id, 'cleft', 'image');
                }
                if($_FILES['fileB']['size'] == 0){
                	
                }else{
                	update_post_meta($post_id, 'cright', 'image');
                }
            }
		$attach_id = media_handle_upload($file,$post_id);
			if($i == 1){
				$image1 = wp_get_attachment_image_src( $attach_id,"full" );
			}else{
				$image2 = wp_get_attachment_image_src( $attach_id,"full" );
			}		
		$i++;
		}
	}
	    
	    update_post_meta($post_id, 'dilA', $dilA);
	    update_post_meta($post_id, 'dilB', $dilB);
	    update_post_meta($post_id, 'winA', 0);
	    update_post_meta($post_id, 'winB',0);
		update_post_meta($post_id,'image1',$image1[0]);
		update_post_meta($post_id,'image2',$image2[0]);


  echo "<b>Thank You!</b> Your Dilemma has been added.";

  die();
} 


function dil_front_upload_image2() {
    
    global $wp_query,$paged,$post,$wp,$wpdb;
    $content = null;
    
    ob_start();
    echo "<br/>";  
	$link = admin_url('admin-ajax.php');
	?>
	  <script language="JavaScript" type="text/javascript">
  function HandleFileButtonClick()
  {
    document.frmUpload.myFile.click();
    document.frmUpload.txtFakeText.value = document.frmUpload.myFile.value;
  }
  
  
	   function readURL(input,type) {
            if (input.files && input.files[0]) {
                var reader = new FileReader();
				console.log(type);
                reader.onload = function (e) {
                    jQuery('#blah' + type)
                        .attr('src', e.target.result)
                        .width('100%')
                        .show();
                    jQuery('#blah2' + type).hide();
                    console.log(jQuery("#blah" + type).height());
                    jQuery("#dil" + type + "img").css("height","100%");
                    jQuery('#txtFakeText').attr('value', e.target.result);
                };

                reader.readAsDataURL(input.files[0]);
            }
        }
 	</script>
	  <script src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.0/jquery-ui.min.js"></script>       
        
        
	<script>
	jQuery(document).ready(function() { 
		
	    var options = { 
	        target:        '#ps_output2',      // target element(s) to be updated with server response 
	        beforeSubmit:  showRequest,     // pre-submit callback 
	        success:       showResponse,    // post-submit callback 
	        url:    	   '<?php echo $link; ?>'         // since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php     
	    }; 
	
	    // bind form using 'ajaxForm' 
	    jQuery('#thumbnail_upload_image').ajaxForm(options); 
	});
	
	function showRequest(formData, jqForm, options) {
	//do extra stuff before submit like disable the submit button
	jQuery('#ps_output2').html('Sending...');
	jQuery('#ajax-image').attr("disabled", "disabled");
	}
	function showResponse(responseText, statusText, xhr, $form)  {
	//do extra stuff after submit
	jQuery('#ajax-image').attr("enabled", "enabled");
	}
	</script>
	  <script src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.0/jquery-ui.min.js"></script>

	  <form id="thumbnail_upload_image" method="post" action="dil_ajax_upload_image" enctype="multipart/form-data" >
	  <label>Dilemma!</label>
	  <br/>
	  <input type="text" name="title" id = "title" style = "width:70%"></br>
	  <br/>
	   <label>Choice A</label><br/>
	   	<div class = "dilAimg">
		<img id="blahA" src="" alt="" style = "border: 0px solid #DFDFDF;" />
		<img id="blah2A" src="" alt="" style = "border: 0px solid #DFDFDF;width: 100px; height: 100px;"/>
		</div>
	  <input type="file" name="fileA" id="fileA" onchange="readURL(this,'A');" data-diltype = "A">
	  <input type="text" name="dilA" id = "dilA" class = 'dilformb' style = "width:70%" required></br>
		<br/>
	   <label>Choice B</label><br/>		
	   	<div class = "dilBimg">
		<img id="blahB" src="" alt="" style = "border: 0px solid #DFDFDF;" />
		<img id="blah2B" src="" alt="" style = "border: 0px solid #DFDFDF;width: 100px; height: 100px;"/>
		</div>
	   <input type="file" name="fileB" id="fileB" onchange="readURL(this,'B');" data-diltype = "B">
	   <input type="text" name="dilB" id = "dilB" class = 'dilformr' style = "width:70%" required></br>
	  <input type="hidden" name="action" id="action" value="dil_upload_action_image">
	  <br/><br/>
	  <?php
	  //MS 8 Sept 2013 ...   this adds the category drop down box, note the $args used
	  
	  			 $args = array(
								    'orderby'            => 'ID', 
								    'order'              => 'ASC',
								    'name'               => 'cat',              //the name of the form element which is grabbed by $_POST['name']
								    'taxonomy'           => 'dilemma-cats',     //this is the dilemma taxonomy as per above 'dilemma-cats'
								    'hide_if_empty'      => false ); 			//you want them to be able to pick empty categories...
								
						?>
					 <br/><label>Category</label><br/>
					  <?php 
				      wp_dropdown_categories($args);     //the function to output them as a dropdown list... 
	
	  ?>
	  <br/><br/>
	  <input id="ajax-image" name="ajax-image" type="submit" value="Add Dilemma">
	  <br/><br/>
	<form>
	
	<div id="ps_output2"></div>
	
    
    <?php
    $content = ob_get_contents();
    ob_end_clean();
    return $content;
    
}

add_shortcode("diluploadimageform", "dil_front_upload_image2");





